;**********************************************************************;
;*                            C E B H A N D                           *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : Bildet das Grundgerst fr ein Assembler-      *;
;*                     Programm, in dem der Ctrl-Break- und  der      *;
;*                     Critical-Error-Interrupt des DOS abgefangen    *;
;*                     werden.                                        *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  :  5.09.1988                                     *;
;*    letztes Update : 19.10.1991                                     *;
;*--------------------------------------------------------------------*;
;*    assemblieren   : MASM CEBHAND;                                  *;
;*                     LINK CEBHAND;                                  *;
;*                                           oder                     *;
;*                     TASM CEBHAND                                   *;
;*                     TLINK CEBHAND                                  *;
;*--------------------------------------------------------------------*;
;*    Aufruf         : CEBHAND                                        *;
;*                     (Bitte dabei das Diskettenlaufwerk A geffnet  *;
;*                      lassen, damit ein Critical-Error auftritt.)   *;
;**********************************************************************;
                                                                        
;== Konstanten =========================================================
                                                                        
                                                                        
;== Stack ==============================================================
                                                                        
stackseg  segment para stack 'STACK' ;Definition des Stack-Segments
                                                                        
          dw 256 dup (?)          ;der Stack ist 256 Words gro
                                                                        
stackseg  ends                    ;Ende des Stack-Segments
                                                                        
;== Daten ==============================================================
                                                                        
data      segment para 'DATA'     ;Definition des Daten-Segments
                                                                        
cr_err    db  0                   ;wird 1, wenn beim Zugriff auf ein
                                  ;Peripheriegerte (Diskette, Festpl.
                                  ;oder Drucker) ein kritischer Fehler
                                  ;aufgetreten ist.
cr_typ    db  0                   ;Fehlernummer des Critical-Error
                                                                        
cr_mes    db  "Kritischer Fehler! (A)bbruch oder (W)iederholen: $"
next_line db  13,10,"$"
end_mes   db  "Programm wurde ordnungsgem beendet.$"
brk_mes   db  "Programm wurde abgebrochen.$"
dat_nam   db  "A:TEST.DAT",0      ;Name der Test-Datei
                                                                        
data      ends                    ;Ende des Daten-Segments
                                                                        
;== Code ===============================================================
                                                                        
code      segment para 'CODE'     ;Definition des CODE-Segments
                                                                        
          assume cs:code, ds:data, ss:stackseg
                                                                        
start     proc far
                                                                        
          ;-- die beiden Interrupt-Handler installieren ----------------
                                                                        
          push cs                 ;CS auf den Stack bringen
          pop  ds                 ;und als DS zurckholen
          mov  ax,2523h           ;Fkt.nr.: Ctrl-Break-Handler setzen
          mov  dx,offset cbreak   ;DS:DX enhlt jetzt Adresse des H.
          int  21h                ;DOS-Interrupt aufrufen
                                                                        
          mov  al,24h             ;jetzt Interrupt 24h setzen
          mov  dx,offset cerror   ;DS:DX enthlt Adresse des neuen H.
          int  21h                ;DOS-Interrupt aufrufen
                                                                        
          mov  ax,data            ;Segmentadresse des Datensegments in
          mov  ds,ax              ;das DS-Register laden
                                                                        
          ;-- hier knnen Sie Ihr Programm ansiedeln -------------------
                                                                        
                                ;
                                ;
                                ;
                                                                        
          ;-- zur Demonstration wird versucht, eine Datei auf dem  -----
          ;-- geffneten Diskettenlaufwerk zu ffnen               -----
                                                                        
dat_open: mov  ah,3dh             ;Fkt.nr.: Datei ffnen
          mov  al,0               ;Dateimodus: nur Lesen
          mov  dx,offset dat_nam  ;DS:DX = Adresse des Dateinamen
          int  21h                ;DOS-Interrupt 21h aufrufen
          jnc  ende               ;kein Fehler? NEIN --> ENDE
                                                                        
          cmp  cr_err,0           ;Critical Error?
          je   ende               ;NEIN --> ENDE
                                                                        
          call crit_err           ;es ist ein kritischer Fehler aufg.
          jmp  dat_open           ;CRIT_ERR kehrt nur zurck, wenn die
                                  ;Operation wiederholt werden soll
                                  ;(ignorieren ist nicht mglich)
                                                                        
          ;-- die Handler mssen vor dem Programmende nicht re-  -------
          ;-- installiert werden, da dies von DOS durchgefhrt wird  ---
                                                                        
ende:     mov  ah,9               ;Fkt.nr.: String ausgeben
          mov  dx,offset end_mes  ;DS:DX = Adresse der Meldung
          int  21h                ;DOS-Interrupt aufrufen
                                                                        
          mov  ax,4C00h           ;Fkt.nr: Programm beenden (ERRCODE=0)
          int  21h                ;DOS-Interrupt aufrufen und das
                                  ;Programm damit beenden
                                                                        
start     endp
                                                                        
;-- CRIT_ERR: wird innerhalb des Programms nach der Entdeckung ---------
;--           eines kritischen Fehlers aufgerufen              ---------
                                                                        
crit_err  proc near
                                                                        
          ;-- Meldung ausgeben und Eingabe des Anwenders abfragen ------
                                                                        
ask:      mov  ah,9               ;Fkt.nr.: String ausgeben
          mov  dx,offset cr_mes   ;DS:DX = Adresse der Meldung
          int  21h                ;DOS-Interrupt aufrufen
                                                                        
          mov  ah,1               ;Fkt.nr.: Zeichen eingeben
          int  21h                ;DOS-Interrupt aufrufen
          push ax                 ;Eingabe merken
                                                                        
          mov  ah,9               ;Fkt.nr.: String ausgeben
          mov  dx,offset next_line;DS:DX = Adresse der Meldung
          int  21h                ;DOS-Interrupt aufrufen
                                                                        
          ;-- die Eingabe des Anwenders auswerten ----------------------
                                                                        
          pop  ax                 ;Eingabe zurckholen
          cmp  al,"A"             ;Abbruch?
          je   end_up             ;zur "Aufrum"-Prozedur
          cmp  al,"a"             ;Abbruch?
          je   end_up             ;zur "Aufrum"-Prozedur
          cmp  al,"w"             ;Wiederholen?
          je   crend              ;JA, zum Prozedurende
          cmp  al,"W"             ;Wiederholen?
          jne  ask                ;NEIN, erneute Abfrage
                                                                        
crend:    ret                     ;zurck zum Aufrufer
                                                                        
crit_err  endp
                                                                        
;-- END_UP: fhrt einen "sauberen Abschlu" durch ----------------------
                                                                        
end_up    proc near
                                                                        
          ;-- hier knnen alle offenen Dateien geschlossen und der  ----
          ;-- vom Programm allokierte System-Speicher wieder frei-  ----
          ;-- gegeben werden                                        ----
                                                                        
                                ;
                                ;
                                ;
                                                                        
          mov  ah,9               ;Fkt.nr.: String ausgeben
          mov  dx,offset brk_mes  ;DS:DX = Adresse der Meldung
          int  21h                ;DOS-Interrupt aufrufen
                                                                        
          mov  ax,4C00h           ;Programm ganz normal ber die
          int  21h                ;Funktion 4Ch beenden
                                                                        
end_up    endp
                                                                        
;-- CBREAK: der neue Ctrl-Break-Handler --------------------------------
                                                                        
cbreak    proc far
                                                                        
          ;-- alle, innerhalb dieser Routine vernderten Register ------
          ;-- (exklusive des Flag-Registers) mssen auf dem Stack ------
          ;-- gesichert werden.                                   ------
                                                                        
          push ds
                                                                        
          mov  ax,data            ;Segmentadresse des Datensegments in
          mov  ds,ax              ;das DS-Register laden
                                                                        
          ;-- hier kann z.B. ein Bildschirmfenster geffnet werden, ----
          ;-- indem der Benutzer gefragt wird, ob er das Programm   ----
          ;-- wirklich beenden mchte.                              ----
                                                                        
                                ;
                                ;
                                ;
                                                                        
          jmp  go_on              ;Programm nicht beenden
                                                                        
          ;-- hat sich der Benutzer fr die Beendigung des Programms ---
          ;-- entschieden, kann hier eine Routine angesprungen       ---
          ;-- werden mit der das Programm abgeschlossen werden kann. ---
                                                                        
          jmp   end_up            ;Programmende vorbereiten
                                                                        
          ;-- das Programm soll nicht abgebrochen, sondern vielmehr  ---
          ;-- ganz normal weitergearbeitet werden                    ---
                                                                        
go_on:    pop   ds                ;gesicherte Register zurckholen
          iret                    ;zurck in's DOS, wo die unterbrochene
                                  ;Funktion normal fortgefhrt wird
cbreak    endp
                                                                        
;-- CERROR: der neue Critical-Error-Handler ----------------------------
                                                                        
cerror    proc far
                                                                        
          ;-- jedes der Register SS, SP, DX, ES, DX, CX und BX, das ----
          ;-- innerhalb dieser Routine verndert wird, mu auf dem  ----
          ;-- Stack gesichert werden.                               ----
                                                                        
          sti                     ;Interrupts wieder erlauben
          push ds
                                                                        
          mov  ax,data            ;Segmentadresse des Datensegments in
          mov  ds,ax              ;das DS-Register laden
                                                                        
          mov  cr_err,1           ;kritischen Fehler anzeigen
          mov  ax,di              ;Fehlernummer nach AX
          mov  cr_typ,al          ;Fehlernummer merken
          mov  al,3               ;Funktionsaufruf mit Fehler beenden
                                                                        
          pop  ds                 ;DS wieder zurckholen
          iret
                                                                        
cerror    endp
                                                                        
;-----------------------------------------------------------------------
                                                                        
code      ends                    ;Ende des Codesegment
          end  start              ;die Programmausfhrung mit der
                                  ;Prozedur START beginnen
