;**********************************************************************;
;*                       C G E R U E S T . A S M                      *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : Gerst fr die Entwicklung eines COM-Programms *;
;*                     in Assembler mit dem Turbo Assembler TASM      *;
;*                     oder Microsofts Macro Assembler MASM           *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  :  7.06.1987                                     *;
;*    letztes Update : 10.10.1991                                     *;
;*--------------------------------------------------------------------*;
;*    Entwicklung    : MASM:   masm cgeruest;                         *;
;*                             link cgeruest;                         *;
;*                             exe2bin cgeruest.exe cgeruest.com      *;
;*                                                                    *;
;*                     TASM:   tasm cgeruest                          *;
;*                             tlink /t cgeruest                      *;
;**********************************************************************;

com       segment para 'CODE'     ;Definition des einen COM-Segments
                                  ;(der Name ist frei whlbar)

          org 100h                ;der Code beginnt an der Adresse 100h
                                  ;unmittelbar hinter dem PSP

          assume cs:com, ds:com, es:com, ss:com

                                  ;alle Segmentregister zeigen whrend 
                                  ;der Programmausfhrung auf auf das 
                                  ;COM-Segment

start:    jmp  init               ;hier beginnt die Programmausfhrung
                                  ;Sprung zur Initialisierungs-Routine

;== Daten ==============================================================

          ;-- hier knnen Sie Ihre gesamten Daten, Puffer und ----------
          ;-- Variablen anlegen

          ;...
          ;...
          ;...

;== Hauptprogramm ======================================================

prog      proc near               ;diese Prozedur ist das eigentliche
                                  ;Hauptprogramm und wird nach der
                                  ;Initialisierung ausgefhrt

          ;-- hier knnen Sie den Programmcode des Hauptprogramms ------
          ;-- unterbringen      

          ;...
          ;...
          ;...

          ;--- Programm mit Hilfe der DOS-Funktion 4Ch beenden ---------

          mov  ax,4C00h           ;Funktinosnummer laden, Fehlercode 0
          int  21h                ;DOS-Aufrufen                   
                                  
          ;--- hier kommt die Programmausfhrung nicht mehr hin, weil --
          ;--- der vorhergehende DOS-Aufruf das Programm beendet hat

prog      endp                    ;Ende des Hauptprogramms

;-- Unterroutinen ------------------------------------------------------
;-- Hier ist Platz fr die verschiedenen Unterroutinen des Programms 

a_proc    proc near

          ;...
          ;...
          ;...
          ret

a_proc    endp 

b_proc    proc near

          ;...
          ;...
          ;...
          ret

b_proc    endp 

;-- Initialisierung ----------------------------------------------------
;-- Hier wird der gesamte Speicher hinter dem Label ENDE freigegeben 
;-- und der Stack herabgesetzt. 

init:     mov  ah,4Ah             ;Fktnummer fr "Speichergre ndern"
          mov  bx,offset ende     ;Lnge des Programms im Speicher
          add  bx,15              ;auf nchsten Paragraphen aufrunden
          mov  cl,4               ;Offsetadresse in Paragraphen um-
          shr  bx,cl              ;rechnen
          inc  bx
          int  21h                ;Funktion ber DOS-Interrupt aufrufen
          
          mov  sp,offset ende     ;Stack herasetzen
          jmp  prog               ;zum Hauptprogramm springen

init_ende label near

;== Stack ==============================================================

          dw (256-((init_ende-init) shr 1)) dup (?)

                                  ;der Stack umfat 256 Words und 
                                  ;schliet dabei den Code der INIT-
                                  ;Routine ein, die nach ihrer Ausfhrung 
                                  ;nicht mehr bentigt wird

ende      equ this byte           ;Ende des belegten Speichers, danach
                                  ;darf kein Code mehr folgen

;== Ende ===============================================================

com       ends                    ;Ende des COM-Segments
          end  start              ;Ende des Assembler-Programms.Bei Aus-
                                  ;fhrung mit dem Befehl START beginnen
