;**********************************************************************;
;*                                E X E C                             *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : Ruft ein beliebiges Programm mit Hilfe der     *;
;*                     EXEC-Funktion des DOS auf. In diesem Beispiel- *;
;*                     Programm wird der Inhalt des Haupt-            *;
;*                     verzeichnisses des aktuellen Laufwerks an-     *;
;*                     gezeigt.                                       *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  :  1.08.87                                       *;
;*    letztes Update : 19.10.91                                       *;
;*--------------------------------------------------------------------*;
;*    assemblieren   : MASM EXEC;                                     *;
;*                     LINK EXEC;                                     *;
;*                                             oder                   *;
;*                     TASM EXEC                                      *;
;*                     TLINK EXEC                                     *;
;*--------------------------------------------------------------------*;
;*    Aufruf         : EXEC                                           *;
;**********************************************************************;
                                                                        
;== Daten ==============================================================
                                                                        
data      segment para 'DATA'     ;Definition des Daten-Segments
                                                                        
prgname   db "c:\command.com",0   ;Name des aufzurufenden Programms
prgpara   db "/c dir",0           ;Parameter werden an das Prg bergeben
                                                                        
          ;-- die verschiedenen Meldungen des Programms

startmes  db " EXEC  -  (c) 1987,91 by Michael Tischer "
          db 13,10,"$"
mesok     db "OK",13,10,"$"
mesnotf   db "Fehler: COMMAND.COM wurde nicht gefunden!",13,10,"$"
meselse   db "Fehler: DOS Fehlercode = "
mescode   db "   ",13,10,"$"

data      ends                    ;Ende des Daten-Segments
                                                                        
;== Code ===============================================================
                                                                        
code      segment para 'CODE'     ;Definition des CODE-Segments
                                                                        
          assume cs:code, ds:data, ss:stackseg
                                                                        
exec      proc far
                                                                        
          mov  ax,data            ;Segmentadresse des Datensegments in
          mov  ds,ax              ;das DS-Register laden
                                                                        
          mov  ah,09h             ;Startmeldung ausgeben
          mov  dx,offset startmes
          int  21h

          call setfree            ;nicht belegten Speicher freigeben
                                                                        
          mov  dx,offset prgname  ;Offsetadresse des Programmnamen
          mov  si,offset prgpara  ;Offsetadresse der Kommandozeile
          call exeprg             ;Programm aufrufen
                                                                        
          mov  dx,offset mesok    ;von fehlerfreier Ausfhrng ausgehen
          jnc  ex_mes             ;kein Fehler ---> Meldung ausgeben

          mov  dx,offset mesnotf  ;wahrscheinlich Programm nicht gef.
          cmp  al,2               ;stimmt's?
          je   ex_mes             ;Ja ---> Meldung ausgeben

          xor  ah,ah              ;Hi-Byte des Fehlercode auf 
          mov  si,offset mescode+2;Fehlercode nach ASCII
          call toint

          mov  dx,offset meselse
ex_mes:   mov  ah,09h             ;String ber DOS ausgeben
          int  21h

          mov  ax,4C00h           ;Programm durch Aufruf einer DOS-Fkt
          int  21h                ;bei bergabe des Fehler-Code 0
                                  ;beenden
                                                                        
exec      endp
                                                                        
;-- SETFREE: den nicht belegten Speicherplatz freigeben ----------------
;-- Eingabe  : ES = Adresse des PSP
;-- Ausgabe  : keine
;-- Register : AX, BX, CL und FLAGS werden verndert
;-- Info     : Da das Stack-Segment immer das letzte Segment in einer
;              EXE-Datei ist, deutet ES:0000 auf den Anfang und SS:SP
;              auf das Ende des Programms im Speicher. Dadurch kann die
;              Lnge des Programms berechnet werden
                                                                        
setfree   proc near
                                                                        
          mov  bx,ss              ;zunchst die beiden Segmentadressen
          mov  ax,es              ;voneinander abziehen. Das ergibt die
          sub  bx,ax              ;Anzahl der Paragraphen vom PSP bis
                                  ;zum Anfang des Stack
          mov  ax,sp              ;da sich der Stackpointer am Ende des
          add  ax,15              ;Stacksegments befindet, gibt sein
          mov  cl,4               ;Inhalt die Lnge des Stacks an
          shr  ax,cl              
          add  bx,ax              ;zur bisherigen Lnge hinzuaddieren
                                                                        
          mov  ah,4ah             ;neue Gre an das DOS bergeben
          int  21h
                                                                        
          ret                     ;zurck zum Aufrufer
                                                                        
setfree   endp
                                                                        
;-- EXEPRG: ein anderes Programm aufrufen ------------------------------
;-- Eingabe  : DS:DX = Adresse des Programmnamen
;--            DS:SI = Adresse der Kommandozeile
;-- Ausgabe  : Carry-Flag = 1 : Fehler (AX = Fehler-Code)
;-- Register : nur AX und FLAGS werden verndert
;-- Info     : Programmname und Kommandozeile mssen als ASCII-String
;--            vorliegen und durch den ASCII-Code 0 abgeschlossen werden
                                                                        
exeprg    proc near
                                                                        
          ;die bergebene Kommmandozeile in eigenen Puffer bertragen --
          ;und dabei die Zeichen zhlen                               --
                                                                        
          push bx                 ;Alle Register sichern, die durch
          push cx                 ;den Aufruf der DOS EXEC-Funktion
          push dx                 ;zerstrt werden
          push di
          push si
          push bp
          push ds
          push es
                                                                        
          mov  di,offset comline+1;Adresse der Zeichen in der Kommandoz.
          push cs                 ;CS auf Stack
          pop  es                 ;als ES zurckholen
          xor  bl,bl              ;Zeichenzhler auf 0 setzen
copypara: lodsb                   ;ein Zeichen auslesen
          or   al,al              ;ist es der NUL-Code (Ende)
          je   copyende           ;JA --> genug kopiert
          stosb                   ;im neuen Puffer abspeichern
          inc  bl                 ;Zeichenzhler inkrementieren
          cmp  bl,126             ;Maximum erreicht?
          jne  copypara           ;NEIN --> weitermachen
                                                                        
copyende: mov  cs:comline,bl      ;Anzahl der Zeichen speichern
          mov  byte ptr es:[di],13;Kommandozeile abschlieen
                                                                        
          mov  cs:merkss,ss       ;SS und SP mssen in Variablen im Code
          mov  cs:merksp,sp       ;Segment gespeichert werden
                                                                        
          mov  bx,offset parblock ;ES:BX zeigt auf Parameter-Block
          mov  ax,4B00h           ;Funktionsnummer fr EXEC-Funktion
          int  21h                ;DOS-Funktion aufrufen
                                                                        
          cli                     ;Interrupts fr einen Augenblick aus
          mov  ss,cs:merkss       ;Stacksegment und Stackpointer wieder
          mov  sp,cs:merksp       ;auf ihre alten Werte setzen
          sti                     ;Interrupts wieder anschalten
                                                                        
          pop  es                 ;alle Register wieder vom Stack holen
          pop  ds
          pop  bp
          pop  si
          pop  di
          pop  dx
          pop  cx
          pop  bx
                                                                        
          jc   exeend             ;Fehler? JA --> Ende
          mov  ah,4dh             ;kein Fehler, Ende-Code des ausge-
          int  21h                ;fhrten Programms abfragen
                                                                        
exeend:   ret                     ;zurck zum Aufrufer
                                                                        
          ;-- Variablen dieser Routine, mur ber CS ansprechbar --------
                                                                        
merkss    dw (?)                  ;nimmt SS whrend Programmaufruf auf
merksp    dw (?)                  ;nimmt SP whrend Programmaufruf auf
                                                                        
parblock  equ this word           ;Parameter-Block fr die EXEC-Funktion
          dw 0                    ;gleicher Environment-Block
          dw offset comline       ;Offset- und Segmentadresse der umge-
          dw seg code             ;bauten Kommandozeile
          dd 0                    ;keine Daten in PSP #1
          dd 0                    ;keine Daten in PSP #2
                                                                        
comline   db 128 dup (?)          ;nimmt die umgebaute Kommandozeile auf
                                                                        
exeprg    endp
                                                                        
;-- TOINT: verwandelt eine Binrzahl in eine ASCII-Zahl und legt sie ---
;--        rechtsbndig in einem Puffer des Aufrufers ab
;-- Eingabe  : DS:SI = Zeiger auf die Position, an der die niederwer-
;--                    tigste Ziffer erscheinen soll
;--            AX    = die umzuwandelnde Binrzahl
;-- Ausgabe  : DS:SI = Zeiger auf die hchstwertige Ziffer
;-- Register : AX, BX, DX, SI und FLAGS werden verndert
;-- Info     : - Der Puffer mu mindestens fnf Zeichen Platz bieten.
;--            - Die Zahl wird rechtsbndig in den Puffer eingetragen.

toint     proc near

          ;-- in einer Schleife die Zahl immer wieder durch 10 teilen ---
          ;-- und dabei die niederwertigste Stelle in das ASCII-Format
          ;-- umwandeln und in den Puffer eintragen

          mov  bx,10              ;Divisor ist immer 10
          jmp  short ti2

ti1:      dec  si                 ;SI auf nachfolgendes Zeichen

ti2:      xor  dx,dx              ;Dividend ist DX:AX
          div  bx                 ;DX:AX durch 10 teilen
          or   dl,'0'             ;DL in das ASCII-Format bringen
          mov  [si],dl            ;im Puffer ablegen
          or   ax,ax              ;bleibt noch ein Rest?
          jne  ti1                ;JA --> nchste Ziffer

          ret                     ;zurck zum Aufrufer

toint     endp

;== Stack ==============================================================
                                                                        
          ;--- Das Stack-Segment mu hier, am Ende der Datei plaziert 
          ;--- werden, damit es nach dem Laden des Programms hinter
          ;--- dem Daten- und Codesegment im Speicher steht

stackseg  segment para stack 'STACK' ;Definition des Stack-Segments
                                                                        
          dw 256 dup (?)          ;der Stack ist 256 Words gro
                                                                        
stackseg  ends                    ;Ende des Stack-Segments
                                                                        
;== Ende ===============================================================
                                                                        
code      ends                    ;Ende des CODE-Segments
          end  exec               ;bei Ausfhrung mit EXEC beginnen
