;**********************************************************************;
;*                          E X E S Y S . A S M                       *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : Stellt das Gerst fr einen Gertetreiber zur  *;
;*                     Verfgung, der auch ber die Kommandozeile     *;
;*                     gestartet werden kann.                         *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  :  1.11.1991                                     *;
;*    letztes Update :  2.11.1991                                     *;
;*--------------------------------------------------------------------*;
;*    assemblieren   : MASM EXESYS;                                   *;
;*                     LINK EXESYS;                                   *;
;*                                                                    *;
;*                     TASM EXESYS       oder                         *;
;*                     TLINK EXESYS                                   *;
;**********************************************************************;
                                                                        
code     segment
                                                                        
	 assume cs:code,ds:code
                                                                        
         org 0                   ;Programm hat keinen PSP daher Anfang
                                 ;an der Offsetadresse 0
                                                                        
;== Konstanten =========================================================
                                                                        
befehl   equ 2                   ;Offset Befehls-Feld im Datenblock
status   equ 3                   ;Offset Status-Feld im Datenblock
end_adr  equ 14                  ;Offset Treiber End-Adr. im Datenblock
                                                                        
;== Daten ==============================================================
                                                                        
;-- Kopf des Gerte-Treibers -------------------------------------------
                                                                        
         dw -1,-1                ;Verbindung zum nchsten Treiber
	 dw 1010000000000000b    ;Treiber Attribut
         dw offset strat         ;Pointer auf Strategie-Routine
         dw offset intr          ;Pointer auf Interrupt-Routine
	 db "$$EXESYS"           ;Name des Treibers
                                                                        
db_ptr   dw (?),(?)              ;Adresse des bergebenen Datenblocks
                                                                        
;=======================================================================
;== Routinen des EXE-Programms =========================================
;=======================================================================

exestart proc far

	 push cs                 ;DS auf CS setzen
	 pop  ds

	 mov  ah,09h             ;Meldung ausgeben
	 mov  dx,offset exemes
	 int  21h

	 mov  ax,4C00h           ;Programm ganz normal beenden
	 int  21h

exestart endp

exemes   db "EXESYS  -  (c) 1991 by Michael Tischer", 13,10,10
	 db "Aufruf als EXE-Programm!", 13, 10, "$"


;=======================================================================
;== Routinen und Funktionen des Treibers ===============================
;=======================================================================
                                                                        
strat    proc far                ;Strategie-Routine
                                                                        
         mov  cs:db_ptr,bx       ;Adresse des Datenblocks in der
         mov  cs:db_ptr+2,es     ;Variable DB_PTR merken
                                                                        
         ret                     ;zurck zum Aufrufer
                                                                        
strat    endp
                                                                        
;-----------------------------------------------------------------------
                                                                        
intr     proc far                ;Interrupt-Routine
                                                                        
         push ax                 ;Register auf Stack sichern
         push bx
         push cx
         push dx
         push di
         push si
         push bp
         push ds
         push es
         pushf                   ;auch das Flag-Register merken
                                                                        
         push cs                 ;Datensegment-Register setzen
         pop  ds                 ;Code ist hier mit Daten identisch
                                                                        
         les  di,dword ptr db_ptr;Adresse des Datenblocks nach ES:DI
	 mov  ax,8003h           ;von Fehler ausgehen
	 cmp  byte ptr es:[di+befehl],00h  ;nur Init-Funktion ist erlaubt
	 jne  short intr_end     ;Fehler, zurck zum Aufrufer
                                                                        
	 call init               ;kann nur Funktion 00h sein
                                                                        
         ;-- Ausfhrung der Funktion beendet ---------------------------
                                                                        
intr_end label near

         or   ax,0100h           ;Fertig-Bit setzen
         mov  es:[di+status],ax  ;das ganze im Status-Feld abspeichern
                                                                        
         popf                    ;Flag-Register zurckholen
         pop  es                 ;andere Register zurckholen
         pop  ds
         pop  bp
         pop  si
         pop  di
         pop  dx
         pop  cx
         pop  bx
         pop  ax
                                                                        
         ret                     ;zurck zum Aufrufer
                                                                        
intr     endp
                                                                        
;-----------------------------------------------------------------------
;-- Bei einem Aufruf als Gertetreiber, wird der Speicher ab hier wieder
;-- freigegeben

init     proc near               ;Initialisierungs-Routine
                                                                        
         mov  word ptr es:[di+end_adr],offset init  ;End-Adresse des
         mov  es:[di+end_adr+2],cs                  ;Treibers setzen
                                                                        
	 mov  ah,09h             ;Meldung ausgeben
	 mov  dx,offset ddmes
	 int  21h

         xor  ax,ax              ;alles o.k.
         ret                     ;zurck zum Aufrufer
                                                                        
init     endp
                                                                        
;-- Daten, die nach der Initialisierung nicht mehr bentigt werden -----

ddmes    db "EXESYS  -  (c) 1991 by Michael Tischer", 13,10,10
	 db "Aufruf als Gertetreiber!", 13, 10, "$"

;=======================================================================
                                                                        
code     ends
	 end exestart
