;**********************************************************************;
;*                            S O U N D A                             *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : gibt die Tonleiter ziwschen den Okatven 3 und  *;
;*                     5 mittels einer universalen Routine zu Ton-    *;
;*                     ausgabe aus                                    *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  :  6.08.87                                       *;
;*    letztes Update : 16.02.91                                       *;
;*--------------------------------------------------------------------*;
;*    assemblieren   : MASM SOUNDA;                                   *;
;*                     LINK SOUNDA;                                   *;
;*                     EXE2BIN SOUNDA SOUNDA.COM                      *;
;*    oder             TASM SOUNDA                                    *;
;*                     TLINK /T SOUNDA                                *;
;*--------------------------------------------------------------------*;
;*    Aufruf         : SOUNDA                                         *;
;**********************************************************************;
                                                                        
code      segment para 'CODE'     ;Definition des CODE-Segments
                                                                        
          org 100h                ;es beginnt an der Adresse 100(h)
                                  ;direkt hinter dem PSP
                                                                        
          assume cs:code, ds:code, es:code, ss:code
                                                                        
;== Programm ===========================================================
                                                                        
sound     proc near
                                                                        
          ;-- Meldung ausgeben -----------------------------------------
                                                                        
          mov  ah,9               ;Funktionsnummer fr String ausgeben
          mov  dx,offset initm    ;Offsetadresse der Meldung
          int  21h                ;DOS-Interrupt aufrufen
                                                                        
          ;-- Tonleitern spielen ---------------------------------------
                                                                        
          xor  bl,bl              ;beim C der dritten Oktave beginnen
          mov  dl,9               ;jeweils eine halbe Sekunde spielen
nextune:  call play_tune          ;Ton spielen
          inc  bl                 ;nchsten Ton
          cmp  bl,36              ;alle Tne der drei Oktaven gespielt?
          jne  nextune            ;NEIN --> nchsten Ton spielen
                                                                        
          ;-- Ende-Meldung ausgeben ------------------------------------
                                                                        
          mov  ah,9               ;Funktionsnummer fr String ausgeben
          mov  dx,offset endmes   ;Offsetadresse der Meldung
          int  21h                ;DOS-Interrupt aufrufen
                                                                        
          mov  ax,4C00h           ;Programm durch Aufruf einer DOS-Fkt
          int  21h                ;bei bergabe des Fehler-Code 0
                                  ;beenden
                                                                        
sound     endp
                                                                        
;== Daten des Hauptprogramms ===========================================
                                                                        
initm     db 13,10,"SOUNDA (c) 1987,91 by Michael Tischer",13,10,13,10
          db "Sofern der Lautsprecher an Ihrem PC nicht defekt ist, "
          db "sollten Sie jetzt",13,10,"die Tonleiter zwischen den "
          db "Oktaven 3 und 5 hren.",13,10,"$"
                                                                        
endmes    db 13,10,"Ende",13,10,"$"
                                                                        
;-- PLAY_TUNE: einen Ton spielen ---------------------------------------
;-- Eingabe  : BL = Nummer des Tones relativ zum C der dritten Oktave
;--            DL = Tondauer in 1/18 Sekunden Schritten
;-- Ausgabe  : keine
;-- Register : AX, CX, ES und FLAGS werden verndert
;-- Info     : erst nach der Tondauer wird die Kontrolle wieder an die
;--            aufrufende Routine bergeben
                                                                        
play_tune proc near
                                                                        
          push dx                 ;DX und BX auf dem Stack merken
          push bx
                                                                        
          ;-- Timer Interrupt auf eigene Routine verbiegen --------------
          push dx                 ;DX und BX auf dem Stack merken
          push bx
          mov  ax,351ch           ;Adresse des Timer-Interrupts holen
          int  21h                ;DOS-Interrupt aufrufen
          mov  time_alt,bx        ;Offsetadresse des alten Interrupts
          mov  time_alt+2,es      ;und Segmentadresse merken
                                                                        
          mov  dx,offset sound_ti ;Offsetadresse der neuen Timer-Routine
          mov  ax,251ch           ;neue Timer-Routine setzen
          int  21h                ;DOS-Interrupt aufrufen
          pop  bx                 ;BX und DX wieder vom Stack holen
          pop  dx
                                                                        
          mov  al,182             ;Erzeugung eines Tones vorbereiten
          out  43h,al             ;Wert an Timer-Command-Register senden
          xor  bh,bh              ;BH fr Adressierung der Ton-Tab. = 0
          shl  bx,1               ;Ton-Nr. verdoppeln (da Word-Tabelle)
          mov  ax,[toene+bx]      ;Ton-Wert holen
          out  42h,al             ;LO-Byte an Timer-Counter-Register
          mov  al,ah              ;HI-Byte an AL bertragen
          out  42h,al             ;und auch an Timer-Counter-Register
          in   al,61h             ;Lautsprecher-Kontroll-Bit einlesen
          or   al,11b             ;untersten beiden Bits schalten Ls. an
          mov  s_ende,1           ;Ton mu erst noch gespielt werden
          mov  s_zaehler,dl       ;Ton-Dauer speichern
          out  61h,al             ;Lautsprecher anschalten
                                                                        
play:     cmp  s_ende,0           ;Ton beendet?
          jne  play               ;NEIN --> noch warten
                                                                        
          in   al,61h             ;Lautsprecher-Kontroll-Bit einlesen
          and  al,11111100b       ;untersten beiden Bits lschen
          out  61h,al             ;Lautsprecher ausschalten
                                                                        
          ;-- alten Timer-Interrupt wieder aktivieren ------------------
                                                                        
          mov cx,ds               ;DS merken
          mov ax,251ch            ;Fkt.nr. fr Interrupt-Vektor setzen
          lds dx,dword ptr time_alt ;alte Adresse nach DS:DX laden
          int 21h                 ;DOS-Interrupt aufrufen
          mov ds,cx               ;DS zurckholen
                                                                        
          pop  bx                 ;BX und DX wieder vom Stack holen
          pop  dx
          ret                     ;zurck zum Aufrufer
                                                                        
play_tune endp
                                                                        
;-- neuer Timer Interrupt ----------------------------------------------
                                                                        
sound_ti  proc far                ;wird 18 mal in der Sekunde aufgerufen
                                                                        
          dec  cs:s_zaehler       ;Zeit-Zhler dekrementieren
          jne  st_ende            ;wenn noch nicht 0 dann Ende
          mov  cs:s_ende,0        ;Notendauer vergangen signalisieren
st_ende:  jmp  dword ptr cs:[time_alt] ;zum alten Timer-Interrupt
                                                                        
sound_ti  endp
                                                                        
;== das sind die Variablen, die die vier Routinen bentigen ============
                                                                        
time_alt  dw (?),(?)              ;Adresse des alten Timer-Interrupt
s_zaehler db (?)                  ;verbleibende Dauer eines Tones in
                                  ;1/18 Sekunden Schritten
s_ende    db (?)                  ;zeigt an, ob Ton bereits gespielt ist
toene     dw 9121,8609,8126,7670  ;Ton-Werte fr die Oktave 3
          dw 7239,6833,6449,6087
          dw 5746,5423,5119,4831
          dw 4560,4304,4063,3834  ;Ton-Werte fr die Oktave 4
          dw 3619,3416,3224,3043
          dw 2873,2711,2559,2415
          dw 2280,2152,2031,1917  ;Ton-Werte fr die Oktave 5
          dw 1809,1715,1612,1521
          dw 1436,1355,1292,1207
                                                                        
;== Ende ===============================================================
                                                                        
code      ends                    ;Ende des CODE-Segments
          end  sound              ;Ende des Assembler-Programms
