'***********************************************************************
'*                            R T C B                                  *
'*---------------------------------------------------------------------*
'*  Aufgabe        : stellt verschiedene Routinen zum Zugriff auf die  *
'*                   Speicherstellen der batteriegepufferten Echzeit-  *
'*                   uhr zur Verfgung                                 *
'*  Autor          : MICHAEL TISCHER                                   *
'*  entwickelt am  : 24.07.87                                          *
'*  letztes Update : 17.02.91                                          *
'***********************************************************************
'
DECLARE FUNCTION RTCRead% (Adresse%)
DECLARE FUNCTION RTCDT% (Adresse%)

CLS                                                  'Bildschirm lschen
PRINT "RTCB (c) 1987, 91 by Michael Tischer": PRINT
PRINT "Informationen aus der batteriegepufferten Echtzeituhr"
PRINT "====================================================="
PRINT

IF (RTCRead(&HE) AND 128) = 128 THEN        'Bit 7 = 0 --> Batterie o.k.
  PRINT "       ACHTUNG! Die Batterie der Uhr ist leer"
ELSE
  PRINT "- die Uhr wird im";
  PRINT (RTCRead(&HB) AND 2) * 6 + 12; "Stunden-Modus betrieben"
 
  PRINT "- die Uhrzeit: ";
  PRINT USING "##:"; RTCDT(&H4);
  PRINT USING "##:"; RTCDT(&H2);
  PRINT USING "##"; RTCDT(&H0)
 
  PRINT "- das Datum: ";
  RESTORE WTage
  Inh% = RTCRead(&H6)
  FOR I% = 1 TO Inh%: READ Tag$: NEXT           'Name des Tages einlesen
  PRINT Tag$; ", der ";
  PRINT USING "##."; RTCDT(&H7);
  PRINT USING "##."; RTCDT(&H8);
  PRINT USING "####"; RTCDT(&H9) + 1900
  PRINT

END IF

WTage:
  DATA "Sonntag", "Montag", "Dienstag", "Mittwoch"
  DATA "Donnerstag", "Freitag", "Samstag"

'**********************************************************************
'* RTCDT: den Inhalt einer der Datums- oder Zeitspeicherstellen aus   *
'*        der RTC auslesen und nach Dezimal wandeln                   *
'*--------------------------------------------------------------------*
'* Eingabe: ADRESSE% = die Nummer der Speicherstelle (0 bis 63)       *
'* Ausgabe: der Inhalt dieser Speicherstelle im Dezimalformat         *
'**********************************************************************
'
FUNCTION RTCDT% (Adresse%)
 
  Ret% = RTCRead(Adresse%)          'Inhalt der Speicherstelle auslesen
  IF (RTCRead(&HB) AND 2) <> 0 THEN                'testen ob BCD-Modus
    RTCDT% = (Ret% AND 15) + INT(Ret% / 16) * 10  'BCD in DEZ umrechnen
  ELSE
    RTCDT% = Ret%
  END IF

END FUNCTION

'***********************************************************************
'* RTCRead: den Inhalt einer der Speicherstellen der RTC auslesen      *
'*---------------------------------------------------------------------*
'* Eingabe: ADRESSE% = die Nummer der Speicherstelle (0 bis 63)        *
'* Ausgabe: der Inhalt dieser Speicherstelle oder -1, wenn ungltige   *
'*          Nummer                                                     *
'***********************************************************************
'
FUNCTION RTCRead% (Adresse%)

  IF (Adresse% < 0) OR (Adresse% > 63) THEN
    RTCRead% = -1
  ELSE
    OUT &H70, Adresse%    'Nummer der Speicherst. an RTC-Adress-Register
    RTCRead% = INP(&H71)        'Inhalt aus dem RTC-Daten-Register lesen
  END IF

END FUNCTION

'***********************************************************************
'* RTCWrite: eine Speicherstelle innerhalb der RTC beschreiben         *
'*---------------------------------------------------------------------*
'* Eingabe: ADRESSE% = die Nummer der Speicherstelle (0 bis 63)        *
'*          INHALT%  = der neue Inhalt dieser Speicherstelle           *
'***********************************************************************
'
SUB RTCWrite (Adresse%, Inhalt%)
 
  OUT &H70, Adresse%  'Nummer der Speicherst. an das RTC-Adress-Register
  OUT &H71, Inhalt%    'neuen Inhalt in das RTC-Daten-Register schreiben

END SUB

