/**********************************************************************/
/*                         E D I T . H                                */
/**------------------------------------------------------------------**/
/*  Aufgabe        : Include-Datei fr Edit                           */
/**------------------------------------------------------------------**/
/*  Autor          : Michael Tischer / Bruno Ferrari                  */
/*  entwickelt am  : 03.05.1994                                       */
/*  letztes Update : 15.05.1994                                       */
/**********************************************************************/
#ifndef _INC_EDIT_H
#define _INC_EDIT_H

#include "win.h"

#define EDIT_DISPLAY 0x0001    /* Editor wird nur zur Anzeige benutzt */
#define EDIT_NOCR    0x0002       /* Editor nimmt kein ENTER entgegen */

typedef struct tagEDIT
{
  WINDOW  Win; /* Window in dem Zeilen des Editors dargestellt werden */
  LPBYTE  lpBuffer;                                 /* Eingabe Buffer */
  UINT    uFlags;                                      /* s. EDIT_??? */

  int     iUsed,                  /* Anzahl der Zeichen im Textbuffer */
          iSize;                    /* Maximale Gre des Textbuffers */

  int     iEditPos;                       /* Aktuelle Eingabeposition */
  int     iEditRow;                          /* Aktuelle Eingabezeile */
  int     iLeftOffset;                     /* Erste angezeigte Spalte */

  int     iRowStarts[ 26 ];                      /* Maximal 25 Zeilen */
} EDIT;
typedef EDIT _far *LPEDIT;

#define CTL_TEXT 0
#define CTL_EDIT 1

typedef struct tagCONTROL
{
  int iX, iY, iW, iH, iA;/* Position, Dimension, Attribut d. Controls */
  LPCHAR lpText;                          /* berschrift des Controls */
  LPBYTE lpBuffer;                       /* Buffer falls Edit-Control */
  UINT   uBufSize;                 /* Buffer Gre Falls Edit-Control */
  UINT   uFlags;                          /* Flags Falls Edit-Control */
  BYTE   bType;                                   /* Typ des Controls */
  LPVOID lpAdditional;            /* Adresse des eigentlichen Objekts */
} CONTROL;
typedef CONTROL far *LPCONTROL;

#endif

