;**********************************************************************;
;*                         L A U F T C A . A S M                      *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : stellt eine Funktion zur Einbindung in das     *;
;*                     Programm LAUFTC.C zur Verfgung, mit deren     *;
;*                     Hilfe ein Zeiger auf die 8*14 Zeichentabelle   *;
;*                     einer EGA-/VGA-Karte ermitteln kann            *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  : 23.08.1990                                     *;
;*    letztes Update : 14.01.1991                                     *;
;*--------------------------------------------------------------------*;
;*    assemblieren   : MASM /mx LAUFTCA;    oder   TASM -mx LAUFTCA   *;
;*                     ... dann mit LAUFTC.C linken                   *;
;**********************************************************************;

IGROUP group _text                ;Zusammenfassung der Programm-Segmente
DGROUP group _bss,  _data         ;Zusammenfassung der Daten-Segmente
       assume CS:IGROUP, DS:DGROUP, ES:DGROUP, SS:DGROUP

_BSS   segment word public 'BSS'  ;dieses Segment nimmt alle nicht ini-
_BSS   ends                       ;tialisierten statischen Variablen auf

_DATA  segment word public 'DATA' ;alle initialisierten globalen und
                                  ;statischen Variablen werden in diesem
                                  ;Segment untergebracht

_DATA  ends

;== Programm ===========================================================

_TEXT  segment byte public 'CODE' ;das Programmsegment

public   _getfontptr              ;Funktion wird fr andere Programme
                                  ;zugnglich

;-- GETFONTPTR: liefert FAR-Pointer auf 8*14 Zeichentabelle ------------
;-- Deklaration : void far * getfontptr( void )

_getfontptr proc near

          push  bp                ;BP sichern

          mov   ax,1130h          ;Register fr Funktionsaufruf laden
          mov   bh,2
          int   10h               ;BIOS-Video-Interrupt aufrufen

          mov   dx,es             ;Zeiger ES:BP in DX:AX zurckliefern
          mov   ax,bp

          pop   bp                ;BP vom Stack zurckholen

          ret                     ;zurck zum Aufrufer

_getfontptr endp                  ;Ende der Prozedur

;== Ende ===============================================================

_text    ends                     ;Ende des Programm-Segments
         end                      ;Ende des Assembler-Source
