/**********************************************************************/
/*                     S E R T R A N S . H                            */
/**------------------------------------------------------------------**/
/*  Aufgabe        : Include File fr SERTRANS.C                      */
/**------------------------------------------------------------------**/
/*  Autor          : Michael Tischer / Bruno Jennrich                 */
/*  entwickelt am  : 08.04.1994                                       */
/*  letztes Update : 18.04.1994                                       */
/**********************************************************************/
#ifndef _INC_SERTRANS_H
#define _INC_SERTRANS_H

#include "types.h"

#define CCITT_POLYNOM 0x1021 /* = x^16 + x^12 + x^5 + x^0 == 0x11021! */

                                                /* einige Ascii-Codes */
#define ASCII_SOH        0x01                 /* Start of Header      */
#define ASCII_STX        0x02                 /* Start of Text / Data */
#define ASCII_EOT        0x03                 /* End of Transmission  */
#define ASCII_ENQ        0x05                              /* Inquiry */
#define ASCII_ACK        0x06                 /* Positive Acknowledge */
#define ASCII_NAK        0x15                 /* Negative Acknowledge */
#define ASCII_SYN        0x16                 /* Synchronus Idle      */

#define PAKET_DATASIZE 512

#define PAKET_FILEOPEN   0                 /* Willkrliche Pakettypen */
#define PAKET_FILECLOSE  1
#define PAKET_FILEDATA   2

typedef struct tagPaket
{
  BYTE bType;                  /* Type des Pakets (Benutzerdefiniert) */
  UINT uDataSize;               /* gltige Daten innerhalb des Pakets */
  UINT uNr;                               /* Sequenznummer des Pakets */
  BYTE bData[ PAKET_DATASIZE ];                              /* Daten */
} PAKET;
typedef PAKET _far *LPPAKET;
typedef PAKET *PPAKET;
                                                   /* Fehlermeldungen */
#define TRANS_SUCCESS        0
#define TRANS_TIMEOUT       -1
#define TRANS_TRANSERROR    -2
#define TRANS_PROTOCOLL     -3
#define TRANS_CRC           -4
#define TRANS_NOFILE        -5

                                /* Action-Codes fr trans_SendPaket() */
#define SEND_RECEIVER   0
#define SEND_SENDING    1
#define SEND_GETNAKLO   2
#define SEND_GETNAKHI   3
#define SEND_PUTCRCLO   4
#define SEND_PUTCRCHI   5
#define SEND_GETREPLY   6


                             /* Action-Codes fr trans_ReceivePaket() */
#define RECEIVE_RECEIVE    0
#define RECEIVE_GETCRCLO   1
#define RECEIVE_GETCRCHI   2
#define RECEIVE_SIGNAL     3 
#define RECEIVE_PUTACK     4
#define RECEIVE_PUTNAK     5
#define RECEIVE_PUTNAKLO   6
#define RECEIVE_PUTNAKHI   7

#define PAKET_SUCCESS   0
#define PAKET_SEQUENCE -10
#define PAKET_UNKNOWN  -11
#define PAKET_TIMEOUT  -12

#endif

