;**********************************************************************;
;*                             M O U S E P A                          *;
;*--------------------------------------------------------------------*;
;*    Aufgabe        : Vom Maustreiber aufgerufener Event-Handler     *;
;*                     zur Einbindung in ein Turbo Pascal Programm.   *;
;*--------------------------------------------------------------------*;
;*    Autor          : MICHAEL TISCHER                                *;
;*    entwickelt am  : 21.04.1989                                     *;
;*    letztes Update :  3.12.1991                                     *;
;*--------------------------------------------------------------------*;
;*    assemblieren   : MASM /MX MOUSEPA;   oder                       *;
;*                     TASM -MX MOUSEPA;                              *;
;*                     ... mit dem Programm MOUSEP verknpfen         *;
;**********************************************************************;

;== Datensegment =======================================================

DATA   segment word public
DATA   ends                       ;keine Variablen in diesem Programm

;== Programm ===========================================================

CODE   segment byte public        ;das Programmsegment

       assume CS:CODE             ;CS zeigt auf das Codesegment, der In-
                                  ;halt von DS, SS und ES ist unbekannt

public     AssHand                ;gibt dem TP-Programm die Mglichkeit,
                                  ;die Adresse des Assembler-Handlers
                                  ;zu ermitteln

extrn     MouEventHandler : near  ;der auzurufende TP-Event-Handler

aktiv     db  0                   ;zeigt an, ob gerade ein Aufruf aus-
                                  ;gefhrt wird

;-----------------------------------------------------------------------
;-- AssHand : der Event-Handler, der zunchst vom Maustreiber aufgerufen
;--           wird, um seinerseits dann die TP-Prozedur MouEventHandler
;--           aufzurufen
;-- Aufruf von TP: nicht erlaubt!

AssHand    proc far

           ;-- zunchst alle Prozessorregister auf dem Stack sichern ---

           cmp  aktiv,0           ;Aufruf noch nicht beendet?
           jne  ende              ;Nein --> Aufruf nicht zulassen

           mov  aktiv,1           ;keine Aufrufe mehr zulassen

           push ax
           push bx
           push cx
           push dx
           push di
           push si
           push bp
           push es
           push ds

           ;-- die Argumente fr den Aufruf der TP-Funktion auf den -----
           ;-- Stack bringen
           ;-- Aufruf: 
           ;--   MouEventHandler (EvFlags, ButStatus, x , y : integer );

           push ax                ;Event-Flags auf den Stack bringen
           push bx                ;Status der Mausknpfe auf den Stack

           mov  di,cx             ;horizontale Ordinate in DI merken
           mov  cl,3              ;Schiebezhler f. Koordinatenumr.

           shr  di,cl             ;DI (horizontale Ord.) durch 8 teilen
           push di                ;und auf den Stack bringen

           shr  dx,cl             ;DX (vertikale Ord.) durch 8 teilen
           push dx                ;und auf den Stack bringen

           mov  ax,DATA           ;Segmentadresse des Datensegments AX
           mov  ds,ax             ;in von dort in das DS-Register

           call  MouEventHandler  ;Aufruf der TP-Prozedur

           ;-- die gesicherten Register wieder vom Stack holen ---------

           pop  ds
           pop  es
           pop  bp
           pop  si
           pop  di
           pop  dx
           pop  cx
           pop  bx
           pop  ax

           mov  aktiv,0           ;Aufruf ist wieder erlaubt

ende:      ret                    ;zurck zum Maustreiber

AssHand    endp

;-------------------------------------------------------------------------

CODE       ends                   ;Ende des Codesegments
           end                    ;Ende des Programms
