{**********************************************************************}
{*                            P R O Z P                               *}
{*--------------------------------------------------------------------*}
{*    Aufgabe        : ermittelt den Typ von Prozessor, mit dem ein   *}
{*                     PC bestckt ist.                               *}
{*--------------------------------------------------------------------*}
{*    Autor          : MICHAEL TISCHER                                *}
{*    entwickelt am  : 16.08.1988                                     *}
{*    letztes Update : 23.08.1994                                     *}
{**********************************************************************}
                                                                        
program PROZP;
                                                                        
{-- Deklaration der Assembler-Routinen --------------------------------}

{$L prozpa}                                { Assembler-Modul einbinden }

function GetProz : integer; external;
function GetCo   : integer; external;

{-- Typen und globale Variable ----------------------------------------}

type  ProName = string[20];                 { Array mit Prozessornamen }

const ProzName : array [0..9] of ProName =
                     ( 'INTEL 8088',                          { Code 0 }
                       'INTEL 8086',                          { Code 1 }
                       'NEC V20',                             { Code 2 }
                       'NEC V30',                             { Code 3 }
                       'INTEL 80188',                         { Code 4 }
                       'INTEL 80186',                         { Code 5 }
                       'INTEL 80286',                         { Code 6 }
                       'INTEL 80386',                         { Code 7 }
                       'INTEL 80486',                         { Code 8 }
                       'Pentium' );                           { Code 9 }

      CoName : array [0..3] of ProName =
                     ( 'Kein Co-Prozessor',                   { Code 0 }
                       '8087',                                { Code 1 }
                       '80287',                               { Code 2 }
                       '80387/80487/Pentium' );               { Code 3 }

{**********************************************************************}
{**                           HAUPTPROGRAMM                          **}
{**********************************************************************}

begin
 writeln(' PROZP (c) 1988-94 by Michael Tischer ');
 writeln;
 writeln('Prozessor   : ', ProzName[ GetProz ] );
 writeln('Co-Prozessor: ', CoName[ GetCo ] );
 writeln;
end.
