{**********************************************************************}
{*                              T Y P M P                             *}
{*--------------------------------------------------------------------*}
{*    Stellt die Typematic-Rate der MF-II-Tastatur ein.               *}
{*--------------------------------------------------------------------*}
{*    Autor          : MICHAEL TISCHER                                *}
{*    entwickelt am  : 27.08.1988                                     *}
{*    letztes Update :  3.01.1992                                     *}
{**********************************************************************}
                                                                        
program TYPMP;
                                                                        
{**********************************************************************}
{* SetTypm: bermittelt die Typematic-Rate an den Tastatur-Controller.*}
{* Eingabe : RATE : die einzustellende Typematic-Rate.                *}
{* Ausgabe : TRUE, wenn der Wert eingestellt werden konnte, FALSE,    *}
{*           wenn ein Fehler beim Zugriff auf den Controller aufge-   *}
{*           treten ist.                                              *}
{* Info    : Diese Funktion ist auch zur Einbindung in eine UNIT      *}
{*           geeignet.                                                *}
{**********************************************************************}
                                                                        
{$F+}                   { diese Funktion verwendet das FAR-Call-Modell }
                                                                        
function SetTypm( Rate : byte ) : boolean;
                                                                        
begin
 inline(
        $32/$D2/$B4/$F3/$FA/$E8/$13/$00/$75/$0A/$8A/$66/$06/$E8/
        $0B/$00/$75/$02/$FE/$C2/$FB/$88/$56/$FF/$EB/$27/$90/$51/
        $53/$B3/$03/$33/$C9/$E4/$64/$A8/$02/$E0/$FA/$8A/$C4/$E6/
        $60/$E4/$64/$A8/$01/$E1/$FA/$E4/$60/$3C/$FA/$74/$07/$FE/
        $CB/$75/$E6/$80/$CB/$01/$5B/$59/$C3
       );
end;
                                                                        
{$F-}
                                                                        
{**********************************************************************}
{**                           HAUPTPROGRAMM                          **}
{**********************************************************************}
                                                                        
var  Delay,                     { nimmt die angegebene Verzgerung auf }
     Speed,               { nimmt die angegebene Wiederholfrequenz auf }
     Fpos1,
     FPos2   : integer;          { Fehlerposition bei Stringumwandlung }
     ParErr : boolean;             { Fehler bei der Parameter-bergabe }
                                                                        
begin
  writeln(#13#10,'TYPMP  -  (c) 1988, 92 by MICHAEL TISCHER');
  ParErr := true;      { zunchst einmal von falscher Eingabe ausgehen }
  if ParamCount = 2 then               { wurden 2 Parameter bergeben? }
    begin                                                         { JA }
      val(ParamStr(1), Delay, FPos1);      { 1. Parameter nach INTEGER }
      val(ParamStr(2), Speed, FPos2);      { 2. Parameter nach INTEGER }
      if ((FPos1=0) and (FPos2=0)) then       { Fehler bei Umwandlung? }
        if ((Delay < 4) and (Speed <32)) then      { Nein, Werte o.k.? }
          ParErr := false;               { Ja, die Parameter sind o.k. }
    end;
  if ( ParErr ) then                        { sind die Parameter o.k.? }
    begin                                                       { Nein }
      writeln('Aufruf: TYPMP  Verzgerung  Wiederholfrequenz');
      writeln('                     ',#30,'              ',#30);
      writeln('                                   ');
      writeln('     ͻ  ͻ');
      writeln('       0 : 1/4 Sekunde      0 : 30,0 W./Sek. ');
      writeln('       1 : 1/2 Sekunde      1 : 26,7 W./Sek. ');
      writeln('       2 : 3/4 Sekunde      2 : 24,0 W./Sek. ');
      writeln('       3 : 1 Sekunde        3 : 21,8 W./Sek. ');
      writeln('     Ķ           .         ');
      writeln('      alle Angaben 20%            .         ');
      writeln('     ͼ           .         ');
      writeln('                             28 :  2,5 W./Sek. ');
      writeln('                             29 :  2,3 W./Sek. ');
      writeln('                             30 :  2,1 W./Sek. ');
      writeln('                             31 :  2,0 W./Sek. ');
      writeln('                            ͼ');
    end
  else                                        { die Paramter sind o.k. }
  begin
    if (SetTypm( (Delay shl 5) + Speed )) then { Typematic-Rate setzen }
      writeln('Die Typematic-Rate wurde eingestellt.')
    else
      writeln('ACHTUNG! Fehler bei Zugriff auf Tastatur-Contoller');
  end;
end.
