{********************************************************************}
{                          V O I C E . P A S                         }
{*------------------------------------------------------------------*}
{ Aufgabe        : Demonstriert den Zugriff auf die Creative-        }
{                  Treiber unter Verwendung des 'Text to Speach'     }
{                  Treibers.                                         }
{*------------------------------------------------------------------*}
{ Autor          : Michael Tischer / Bruno Jennrich                  }
{ entwickelt am  : 20.03.1994                                        }
{ letztes Update : 10.10.1994                                        }
{********************************************************************}
{$m 16000,16000,16000}
{$X+}                              { Funktionsegebnisse optional }

Uses SBUTIL,CTTS,ARGS,DOS;

var lpEntry : Longint;                            { Treibereinsprung }
    iGender,
    iTone,
    iVolume,
    iPitch,
    iSpeed    : Integer;
    Argumente : NArgStrings;
    ver       : Word;

{********************************************************************}
{          H A U P T P R O G R A M M                                 }
{********************************************************************}
Begin
  iGender := 0;                                        { Geschlecht }
  iGender := GetArg( '-FEMALE', _none, NIL, 0 );

  iTone := 0;                                                 { Ton }
  iTone := GetArg( '-TREBLE', _none, NIL, 0 );

  iVolume := 5;                                        { Lautstrke }
  GetArg( '-VOL:', _int, @iVolume, 1 );

  iPitch := 5;                                            { Tonhhe }
  GetArg( '-PITCH:', _int, @iPitch, 1 );

  iSpeed := 5;                                    { Geschwindigkeit }
  GetArg( '-SPEED:', _int, @iSpeed, 1 );

  if GetNArg( '-', Argumente )  = 0 then
    Begin
      Writeln( 'Aufruf: voice TEXT [ -FEMALE][ -TREBLE]' );
      Writeln( '[ -VOL:0-9][ -PITCH:0-9][ -SPEED:0-9 ]' );
      Halt( 0 );
    End;

  lpEntry := sb_LoadDriver( 'CTTS.DRV' );         { CTTS-Driver laden }

  if lpEntry = 0 then
    Writeln( 'Konnte "CTTS.DRV" nicht finden!' )
  else
    Begin
      {-- BLASTER-Umgebungsvariable auswerten -----------------------}
      if ctts_GetEnvSettings( lpEntry ) <> 0 then
        Writeln( 'Fehler in BLASTER-Environment Variable' )
      else
        if ctts_Init( lpEntry ) <> 0 then        { Treiber initialisieren }
          Writeln( 'CTTS konnte nicht initialisiert werden' )
        else
          Begin
            ver := ctts_GetDrvVer( lpEntry );        { Versionsnummer holen }
            Writeln( ' CTTS-Version: ', ver shr 8, '.', ver and $ff );
            ctts_SetSpeechParam( lpEntry,         { Sprachparameter setzen }
                                 iGender,
                                 iTone,
                                 iVolume,
                                 iPitch,
                                 iSpeed );
            ctts_Say( lpEntry, Argumente[0] );           { Sprchlein aufsagen... }
            ctts_Terminate( lpEntry );                          { und Ende }
          End;
      sb_UnloadDriver( lpEntry ); { Treiber entfernen }
    End;
End.

